SystemOrganization addCategory: #'Mustache-Seaside-Core'!

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData
	"returns function call to renderize Mustache template."
	
self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:21'!
mustache: aTemplate data:theData command:aString
	"returns function call to renderize Mustache template."
	
self call:aString with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData partials:anArrayOfPartials
	"returns function call to renderize Mustache template."

self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/18/2013 13:58'!
mustache: aTemplate data:theData partials:anArrayOfPartials command:anString
	"returns function call to renderize Mustache template.
	'how'' must be append after "

self call:anString with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

!WAHtmlCanvas methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 12/5/2012 15:36'!
mustache
	^ ( WAMustacheTag on:self)! !

Object subclass: #WAMustacheSectionTag
	instanceVariableNames: 'inverted html name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheSectionTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:32'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html
	^ html! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html: anObject
	html := anObject! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:43'!
initialize
inverted:=false! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
inverted
inverted:=true! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:39'!
name:aSectionName
name:=aSectionName! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
with:aBlock
self html  flush.
self html document nextPutAll: (inverted ifFalse:['{{#',name,'}}'] ifTrue:['{{^',name,'}}']).
self html  flush.
aBlock value.
self html  flush.
self html document nextPutAll: '{{/',name,'}}'.! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:03'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 2/5/2013 18:15'!
html
^html! !

!WAMustacheTag methodsFor: 'private' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 3/8/2013 10:37'!
partial:aPartialName
self html flush.
self html document nextPutAll: '{{>',aPartialName,'}}'.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:38'!
section
^ WAMustacheSectionTag on:html! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 2/5/2013 18:07'!
template
^template! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
unescapedVariable:aName

^'{{&',aName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
variable:aName
^'{{',aName,'}}'! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 16:27'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template class superclass = MustacheTemplate class)  ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 22:24'!
with: aBlock
self html flush.
self html document nextPutAll:'<script id="'.
self html document nextPutAll: self template.
self html document nextPutAll:'" type="text/x-jquery-tmpl">'.
aBlock value.
self html document nextPutAll:'</script>'.
self html flush.! !

MustacheTemplate subclass: #MuSTemplate
	instanceVariableNames: 'fullDocument builder document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!MuSTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/16/2013 13:08'!
instance
|sub evently|
super initialize.
instance:=self new.
evently := instance evently. 
"subclesses heritage scriptgeterator and evently"
self subclasses do:[:aSubClass|
	instance addPartial: (aSubClass instance 
							fullDocument:false;
							setScriptGenerator:instance getScriptGenerator;
							evently:evently;
							yourself).
].
instance initialize.
^instance! !

!MuSTemplate methodsFor: 'accessing' stamp: 'JesusMari 2/22/2013 11:13'!
fullDocument
	^ fullDocument! !

!MuSTemplate methodsFor: 'accessing' stamp: 'JesusMari 2/22/2013 11:13'!
fullDocument: anObject
	fullDocument := anObject! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:22'!
getHtmlBuilder
builder ifNil:[^ builder:=WAHtmlCanvas builder] ifNotNil:[^builder].
 ! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:23'!
getHtmlDocument
document ifNil:[^ document:=self getHtmlBuilder documentClass new] ifNotNil:[^document].
 ! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 19:14'!
getScriptGenerator
^ self getHtmlDocument scriptGenerator.
 ! !

!MuSTemplate methodsFor: 'initialize-release' stamp: 'JesusMari 2/22/2013 11:14'!
initialize
fullDocument := false.! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 8/20/2013 16:03'!
render
"return the renderized html content included in renderContentOn:"
|  result  htmlRoot|
"initialize evently node"
self removeKey:'evently'.
self reset.
builder:=self getHtmlBuilder.
document:= self getHtmlDocument.
self fullDocument ifTrue:[
	htmlRoot:=builder rootClass new.
	self updateRoot:htmlRoot.
	htmlRoot writeHeadOn: document].
WACurrentRequestContext 
		use: self requestContext
		during: [
			 document nextPutAll:  (builder render: [:h | self renderContentOn:h]). ].

self fullDocument ifTrue:[
	htmlRoot writeFootOn: document.
	self evently notNil ifTrue:[self perform: #writeEventlyFooterOn: with: document stream ].
	].
^ document stream contents

! !

!MuSTemplate methodsFor: 'abstract' stamp: 'JesusMari 2/20/2013 20:12'!
renderContentOn:html
self subclassResponsibility! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 2/28/2013 03:45'!
requestContext

^WARequestContext  
		request: WARequest new
		response: WAResponse new
		codec: GRNullCodec new! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 8/20/2013 16:03'!
reset
document:=nil.
builder:=nil! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:24'!
setHtmlBuilder:aBuilder
builder:=aBuilder! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:25'!
setHtmlDocument:aDoc
document:=aDoc! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 19:28'!
setScriptGenerator:aScriptGenerator

^ self getHtmlDocument scriptGenerator:aScriptGenerator.
 ! !

!MuSTemplate methodsFor: 'abstract' stamp: 'JesusMari 2/22/2013 10:45'!
updateRoot:anHtmlRoot
"everwrite this method to include headers"
! !
